/* example-start tictactoe tictactoe.h */

/* GTK - The GIMP Toolkit
 * Copyright (C) 1995-1997 Peter Mattis, Spencer Kimball and Josh MacDonald
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */
#ifndef __TICTACTOE_H__
#define __TICTACTOE_H__


#include <gdk/gdk.h>
#include <gtk/gtkvbox.h>


#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#define TICTACTOE(obj)          GTK_CHECK_CAST (obj, tictactoe_get_type (), Tictactoe)
#define TICTACTOE_CLASS(klass)  GTK_CHECK_CLASS_CAST (klass, tictactoe_get_type (), TictactoeClass)
#define IS_TICTACTOE(obj)       GTK_CHECK_TYPE (obj, tictactoe_get_type ())


typedef struct _Tictactoe       Tictactoe;
typedef struct _TictactoeClass  TictactoeClass;

struct _Tictactoe
{
  GtkVBox vbox;
  
  GtkWidget *buttons[3][3];
};

struct _TictactoeClass
{
  GtkVBoxClass parent_class;

  void (* tictactoe) (Tictactoe *ttt);
};

guint          tictactoe_get_type        (void);
GtkWidget*     tictactoe_new             (void);
void	       tictactoe_clear           (Tictactoe *ttt);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#if defined(_CHDLL_)
#include <dlfcn.h>
void *_ChGtkTictactoe_handle = _dlopen("libgtktictactoe.dl", RTLD_LAZY);
if(_ChGtkTictactoe_handle == NULL) {
   fprintf(_stderr, "Error: dlopen(): %s\n", dlerror());
   fprintf(_stderr, "       cannot get _ChGtkTictactoe_handle in tictactoe.h\n");
   exit(-1);
} /* dlclose(_ChGtkTictactoe_handle) will never be called */


void tictactoe_clear(Tictactoe *ttt) {
    void *fptr;

    fptr = dlsym(_ChGtkTictactoe_handle, "tictactoe_clear_chdl");
    if(fptr == NULL) {
        fprintf(_stderr, "Error: %s(): dlsym(): %s\n", __func__,  dlerror());
    }
    dlrunfun(fptr, NULL, tictactoe_clear, ttt);
}

guint tictactoe_get_type() {
    void *fptr;
    guint retval;

    fptr = dlsym(_ChGtkTictactoe_handle, "tictactoe_get_type_chdl");
    if(fptr == NULL) {
        fprintf(_stderr, "Error: %s(): dlsym(): %s\n", __func__,  dlerror());
        return -1;
    }
    dlrunfun(fptr, &retval,tictactoe_get_type);
    return retval;
}

GtkWidget* tictactoe_new() {
    void *fptr;
    GtkWidget* retval;

    fptr = dlsym(_ChGtkTictactoe_handle, "tictactoe_new_chdl");
    if(fptr == NULL) {
        fprintf(_stderr, "Error: %s(): dlsym(): %s\n", __func__,  dlerror());
        return NULL;
    }
    dlrunfun(fptr, &retval,tictactoe_new);
    return retval;
}

#endif /* _CHDLL_ */

#endif /* __TICTACTOE_H__ */

/* example-end */
